{-
Copyright 2009 Christian Sternagel, René Thiemann, Sarah Winkler, Harald Zankl

This file is part of IsaFoR/CeTA.

IsaFoR/CeTA is free software: you can redistribute it and/or modify it under the
terms of the GNU Lesser General Public License as published by the Free Software
Foundation, either version 3 of the License, or (at your option) any later
version.

IsaFoR/CeTA is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License along
with IsaFoR/CeTA. If not, see <http://www.gnu.org/licenses/>.
-}
module Main(main) where 
import ProofChecker;
import Util;
import Term;
import Trs;
import Show;
import System;
import System.IO;

main = do args <- getArgs
          case length args of
            1 -> do trsString <- hGetContents stdin
                    prfString <- readFile (args !! 0)
                    start trsString prfString
            2 -> do trsString <- readFile (args !! 0)
                    prfString <- readFile (args !! 1)
                    start trsString prfString
            _ -> do putStr ("usage: CeTA [trsFile] prfFile\n" ++
                           "(If trsFile is omitted then it is read from stdin)\n")

start trsString prfString = 
    do let trs = (read trsString) :: [(Term String String,Term String String)]
       let prf = (read prfString) :: TRSProof String String
       case checkTRSProof trs prf of
         Lefta err -> error (showLista err)
         Righta _  -> case prf of 
           DPTrans _ _ -> putStr ("Successfully proved termination of\n" ++ (showLista (showTRS trs)))
           Loop _      -> putStr ("Successfully proved nontermination of\n" ++ (showLista (showTRS trs)))
