{-
Copyright 2009 Christian Sternagel, René Thiemann, Sarah Winkler, Harald Zankl

This file is part of IsaFoR/CeTA.

IsaFoR/CeTA is free software: you can redistribute it and/or modify it under the
terms of the GNU Lesser General Public License as published by the Free Software
Foundation, either version 3 of the License, or (at your option) any later
version.

IsaFoR/CeTA is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License along
with IsaFoR/CeTA. If not, see <http://www.gnu.org/licenses/>.
-}
module RedPair where {

import Show;
import Term;
import Util;
import ErrorMonad;
import List;
import Product_Type;
import HOL;

checkRedPairProc ::
  forall a b.
    (Eq a, Sshow a, Eq b,
      Sshow b) => ((Term a b, Term a b) -> Eithera [[Char]] ()) ->
                    ((Term a b, Term a b) -> Eithera [[Char]] ()) ->
                      [Char] ->
                        [[Char]] ->
                          [(Term a b, Term a b)] ->
                            [(Term a b, Term a b)] ->
                              [(Term a b, Term a b)] -> Eithera [[Char]] ();
checkRedPairProc checkSS checkNSS name representation p rP r =
  let {
    a = computeSplit (\ foo -> isValue (checkSS foo)) p;
    (sp, nSp) = a;
  } in catcha
         (bind (bind (catcha
                       (catcha (checkAllMI checkNSS r) (\ x -> errora (snd x)))
                       (\ x -> errora ("problem when orienting TRS" : x)))
                 (\ x ->
                   catcha
                     (catcha (checkAllMI checkNSS nSp)
                       (\ xa -> errora (snd xa)))
                     (\ xa -> errora ("problem when orienting DPs" : xa))))
           (\ x ->
             catcha (checkSubset nSp rP)
               (\ xa ->
                 errora
                   (case checkSS xa of {
                     Lefta err -> err;
                     Righta ok ->
                       ["internal error",
                         "please contact one of the CeTA members",
                         "http://cl-informatik.uibk.ac.at/software/ceta",
                         "ceta@informatik.uibk.ac.at"];
                   }))))
         (\ x ->
           errora
             ("could not apply the reduction pair processor with the following"
               : append representation ([] : x)));

}
